1. 程式人生 > >POJ 3216 Prime Path(寬搜+篩素數)

POJ 3216 Prime Path(寬搜+篩素數)

POJ 3216
Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input

3
1033 8179
1373 8017
1033 1033
Sample Output

6
7
0
題意:多組輸入,每次給你兩個四位數,要求每次將前者改變一位數字,問最少經過多少次變換使之變成後者(注:每次改變後的數字必須為素數,且第一位數字不能為0)。

題解:
埃氏篩法+BFS

#include<iostream>
#include<cstdio>
#include<cstring>
#include<queue> 
using namespace std;
bool p[20000+10];
bool used[10000+10];
string n,m;
struct cc{
	string x;
	int step;
};
queue<cc>q; 
void bfs(string s)
{
	q.push((cc){s,0});
	while(!q.empty())
	{
		cc now=q.front(); q.pop();
		if(now.x==m)
		{
			printf("%d\n",now.step);
			break;
		}
		for(int i=0;i<4;i++)
		{
			for(int j=0;j<=9;j++)
			{
				if(i==0&&j==0)//第一個數字不能為0 
				{
					continue;
				}
				cc hh=now;
				hh.x[i]=j+'0';
				int sz=0;
				for(int k=0;k<4;k++)
				{
					sz*=10;
					sz+=hh.x[k]-'0';
				}
				if(p[sz]&&!used[sz])//判斷當前數字是否為素數且是否已被使用過 
				{
					q.push((cc){hh.x,hh.step+1});
					used[sz]=1;
				}
			}
		}
	}
}
int main()
{
	memset(p,1,sizeof(p));//篩素數
	p[0]=0,p[1]=0;
	for(int i=2;i<=9999;i++)
	{
		if(p[i])
		{
			for(int j=i+i;j<=9999;j+=i)
			{
			    p[j]=0;
			}
		}
	}
	int T;
	scanf("%d",&T);
	for(int k=1;k<=T;k++)
	{
		cin>>n>>m;
		memset(used,0,sizeof(used));
		while(!q.empty())
		{
			q.pop();
		}
	    bfs(n);
	}
    return 0;
}